#ifndef _H_D30F3C60CCCFF90DA285D5F639C002B6_AhbcGradual__H_
#define _H_D30F3C60CCCFF90DA285D5F639C002B6_AhbcGradual__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AhbcGradual_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float boundary_domain_bottom_non_glare_hlb_;
                ::DDS::Float boundary_domain_non_glare_left_hand_hlb_;
                ::DDS::Float boundary_domain_non_glare_right_hand_hlb_;
                ::DDS::UShort object_distance_hlb_;
                ::DDS::Octet status_boundary_domain_bottom_non_glare_hlb_;
                ::DDS::Octet status_boundary_domain_non_glare_left_hand_hlb_;
                ::DDS::Octet status_boundary_domain_non_glare_right_hand_hlb_;
                ::DDS::Octet status_object_distance_hlb_;
                ::DDS::Boolean left_target_change_;
                ::DDS::Boolean right_target_change_;
                ::DDS::Boolean too_many_cars_;
                ::DDS::Boolean busy_scene_;
            };

            typedef DDS_DCPSStruct_var<AhbcGradual_> AhbcGradual__var;
            typedef DDS_DCPSStruct_out < AhbcGradual_> AhbcGradual__out;

        }

    }

}

#endif /* _H_D30F3C60CCCFF90DA285D5F639C002B6_AhbcGradual__H_ */
