#ifndef _H_A171D4CA735AA23FA659C31A32DBCEC7_Ahbc__H_
#define _H_A171D4CA735AA23FA659C31A32DBCEC7_Ahbc__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Ahbc_Constants
            {
                const ::DDS::Octet HIGH_LOW_BEAM_DECISION_NO_RECOMMENDATION_ = 0;

                const ::DDS::Octet HIGH_LOW_BEAM_DECISION_RECOMMENDATION_OFF_ = 1;

                const ::DDS::Octet HIGH_LOW_BEAM_DECISION_RECOMMENDATION_ON_ = 2;

                const ::DDS::Octet HIGH_LOW_BEAM_DECISION_INVALID_ = 3;

            }

            struct  Ahbc_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet high_low_beam_decision_;
                ::DDS::UShort reasons_for_switch_to_low_beam_;
            };

            typedef DDS_DCPSStruct_var<Ahbc_> Ahbc__var;
            typedef DDS_DCPSStruct_out < Ahbc_> Ahbc__out;

        }

    }

}

#endif /* _H_A171D4CA735AA23FA659C31A32DBCEC7_Ahbc__H_ */
