#ifndef _H_8E55AC14D23DB0893A8FF730D013A052_AwsDisplay_DCPS_H_
#define _H_8E55AC14D23DB0893A8FF730D013A052_AwsDisplay_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AwsDisplay_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AwsDisplay_TypeSupportInterface;

            typedef AwsDisplay_TypeSupportInterface * AwsDisplay_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AwsDisplay_TypeSupportInterface> AwsDisplay_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AwsDisplay_TypeSupportInterface> AwsDisplay_TypeSupportInterface_out;


            class AwsDisplay_DataWriter;

            typedef AwsDisplay_DataWriter * AwsDisplay_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AwsDisplay_DataWriter> AwsDisplay_DataWriter_var;
            typedef DDS_DCPSInterface_out < AwsDisplay_DataWriter> AwsDisplay_DataWriter_out;


            class AwsDisplay_DataReader;

            typedef AwsDisplay_DataReader * AwsDisplay_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AwsDisplay_DataReader> AwsDisplay_DataReader_var;
            typedef DDS_DCPSInterface_out < AwsDisplay_DataReader> AwsDisplay_DataReader_out;


            class AwsDisplay_DataReaderView;

            typedef AwsDisplay_DataReaderView * AwsDisplay_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AwsDisplay_DataReaderView> AwsDisplay_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AwsDisplay_DataReaderView> AwsDisplay_DataReaderView_out;

            struct AwsDisplay_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AwsDisplay_, struct AwsDisplay_Seq_uniq_> AwsDisplay_Seq;
            typedef DDS_DCPSSequence_var < AwsDisplay_Seq> AwsDisplay_Seq_var;
            typedef DDS_DCPSSequence_out < AwsDisplay_Seq> AwsDisplay_Seq_out;

            class  AwsDisplay_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AwsDisplay_TypeSupportInterface_ptr _ptr_type;
                typedef AwsDisplay_TypeSupportInterface_var _var_type;

                static AwsDisplay_TypeSupportInterface_ptr _duplicate (AwsDisplay_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AwsDisplay_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AwsDisplay_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AwsDisplay_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AwsDisplay_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AwsDisplay_TypeSupportInterface () {};
                ~AwsDisplay_TypeSupportInterface () {};
            private:
                AwsDisplay_TypeSupportInterface (const AwsDisplay_TypeSupportInterface &);
                AwsDisplay_TypeSupportInterface & operator = (const AwsDisplay_TypeSupportInterface &);
            };

            class  AwsDisplay_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AwsDisplay_DataWriter_ptr _ptr_type;
                typedef AwsDisplay_DataWriter_var _var_type;

                static AwsDisplay_DataWriter_ptr _duplicate (AwsDisplay_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AwsDisplay_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AwsDisplay_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AwsDisplay_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AwsDisplay_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AwsDisplay_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AwsDisplay_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AwsDisplay_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AwsDisplay_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AwsDisplay_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AwsDisplay_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AwsDisplay_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AwsDisplay_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AwsDisplay_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AwsDisplay_& instance_data) = 0;

            protected:
                AwsDisplay_DataWriter () {};
                ~AwsDisplay_DataWriter () {};
            private:
                AwsDisplay_DataWriter (const AwsDisplay_DataWriter &);
                AwsDisplay_DataWriter & operator = (const AwsDisplay_DataWriter &);
            };

            class  AwsDisplay_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AwsDisplay_DataReader_ptr _ptr_type;
                typedef AwsDisplay_DataReader_var _var_type;

                static AwsDisplay_DataReader_ptr _duplicate (AwsDisplay_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AwsDisplay_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AwsDisplay_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AwsDisplay_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AwsDisplay_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AwsDisplay_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AwsDisplay_& instance) = 0;

            protected:
                AwsDisplay_DataReader () {};
                ~AwsDisplay_DataReader () {};
            private:
                AwsDisplay_DataReader (const AwsDisplay_DataReader &);
                AwsDisplay_DataReader & operator = (const AwsDisplay_DataReader &);
            };

            class  AwsDisplay_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AwsDisplay_DataReaderView_ptr _ptr_type;
                typedef AwsDisplay_DataReaderView_var _var_type;

                static AwsDisplay_DataReaderView_ptr _duplicate (AwsDisplay_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AwsDisplay_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AwsDisplay_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AwsDisplay_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AwsDisplay_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AwsDisplay_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AwsDisplay_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AwsDisplay_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AwsDisplay_& instance) = 0;

            protected:
                AwsDisplay_DataReaderView () {};
                ~AwsDisplay_DataReaderView () {};
            private:
                AwsDisplay_DataReaderView (const AwsDisplay_DataReaderView &);
                AwsDisplay_DataReaderView & operator = (const AwsDisplay_DataReaderView &);
            };
        }

    }

}

#endif
