#ifndef _H_8C4889EFE34C5FFE1B8410409ED3BF36_FixedFoe_DCPS_H_
#define _H_8C4889EFE34C5FFE1B8410409ED3BF36_FixedFoe_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FixedFoe_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FixedFoe_TypeSupportInterface;

            typedef FixedFoe_TypeSupportInterface * FixedFoe_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FixedFoe_TypeSupportInterface> FixedFoe_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FixedFoe_TypeSupportInterface> FixedFoe_TypeSupportInterface_out;


            class FixedFoe_DataWriter;

            typedef FixedFoe_DataWriter * FixedFoe_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FixedFoe_DataWriter> FixedFoe_DataWriter_var;
            typedef DDS_DCPSInterface_out < FixedFoe_DataWriter> FixedFoe_DataWriter_out;


            class FixedFoe_DataReader;

            typedef FixedFoe_DataReader * FixedFoe_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FixedFoe_DataReader> FixedFoe_DataReader_var;
            typedef DDS_DCPSInterface_out < FixedFoe_DataReader> FixedFoe_DataReader_out;


            class FixedFoe_DataReaderView;

            typedef FixedFoe_DataReaderView * FixedFoe_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FixedFoe_DataReaderView> FixedFoe_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FixedFoe_DataReaderView> FixedFoe_DataReaderView_out;

            struct FixedFoe_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FixedFoe_, struct FixedFoe_Seq_uniq_> FixedFoe_Seq;
            typedef DDS_DCPSSequence_var < FixedFoe_Seq> FixedFoe_Seq_var;
            typedef DDS_DCPSSequence_out < FixedFoe_Seq> FixedFoe_Seq_out;

            class  FixedFoe_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FixedFoe_TypeSupportInterface_ptr _ptr_type;
                typedef FixedFoe_TypeSupportInterface_var _var_type;

                static FixedFoe_TypeSupportInterface_ptr _duplicate (FixedFoe_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FixedFoe_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FixedFoe_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FixedFoe_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FixedFoe_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FixedFoe_TypeSupportInterface () {};
                ~FixedFoe_TypeSupportInterface () {};
            private:
                FixedFoe_TypeSupportInterface (const FixedFoe_TypeSupportInterface &);
                FixedFoe_TypeSupportInterface & operator = (const FixedFoe_TypeSupportInterface &);
            };

            class  FixedFoe_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FixedFoe_DataWriter_ptr _ptr_type;
                typedef FixedFoe_DataWriter_var _var_type;

                static FixedFoe_DataWriter_ptr _duplicate (FixedFoe_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FixedFoe_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FixedFoe_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FixedFoe_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FixedFoe_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FixedFoe_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FixedFoe_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FixedFoe_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FixedFoe_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FixedFoe_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FixedFoe_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FixedFoe_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FixedFoe_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FixedFoe_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FixedFoe_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FixedFoe_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FixedFoe_& instance_data) = 0;

            protected:
                FixedFoe_DataWriter () {};
                ~FixedFoe_DataWriter () {};
            private:
                FixedFoe_DataWriter (const FixedFoe_DataWriter &);
                FixedFoe_DataWriter & operator = (const FixedFoe_DataWriter &);
            };

            class  FixedFoe_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FixedFoe_DataReader_ptr _ptr_type;
                typedef FixedFoe_DataReader_var _var_type;

                static FixedFoe_DataReader_ptr _duplicate (FixedFoe_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FixedFoe_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FixedFoe_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FixedFoe_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FixedFoe_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FixedFoe_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FixedFoe_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FixedFoe_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FixedFoe_& instance) = 0;

            protected:
                FixedFoe_DataReader () {};
                ~FixedFoe_DataReader () {};
            private:
                FixedFoe_DataReader (const FixedFoe_DataReader &);
                FixedFoe_DataReader & operator = (const FixedFoe_DataReader &);
            };

            class  FixedFoe_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FixedFoe_DataReaderView_ptr _ptr_type;
                typedef FixedFoe_DataReaderView_var _var_type;

                static FixedFoe_DataReaderView_ptr _duplicate (FixedFoe_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FixedFoe_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FixedFoe_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FixedFoe_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FixedFoe_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FixedFoe_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FixedFoe_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FixedFoe_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FixedFoe_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FixedFoe_& instance) = 0;

            protected:
                FixedFoe_DataReaderView () {};
                ~FixedFoe_DataReaderView () {};
            private:
                FixedFoe_DataReaderView (const FixedFoe_DataReaderView &);
                FixedFoe_DataReaderView & operator = (const FixedFoe_DataReaderView &);
            };
        }

    }

}

#endif
