#ifndef _H_8729E3A314B72B29673A08693B668B5C_Lane__H_
#define _H_8729E3A314B72B29673A08693B668B5C_Lane__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Lane_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double lane_curvature_;
                ::DDS::Double lane_heading_;
                ::DDS::Boolean construction_area_;
                ::DDS::Double pitch_angle_;
                ::DDS::Double yaw_angle_;
                ::DDS::Boolean right_ldw_availability_;
                ::DDS::Boolean left_ldw_availability_;
            };

            typedef DDS_DCPSStruct_var<Lane_> Lane__var;
            typedef DDS_DCPSStruct_out < Lane_> Lane__out;

        }

    }

}

#endif /* _H_8729E3A314B72B29673A08693B668B5C_Lane__H_ */
