#ifndef _H_4DD041D5B8D7FC3FAD996605107E86F3_LkaLane_DCPS_H_
#define _H_4DD041D5B8D7FC3FAD996605107E86F3_LkaLane_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LkaLane_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LkaLane_TypeSupportInterface;

            typedef LkaLane_TypeSupportInterface * LkaLane_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LkaLane_TypeSupportInterface> LkaLane_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LkaLane_TypeSupportInterface> LkaLane_TypeSupportInterface_out;


            class LkaLane_DataWriter;

            typedef LkaLane_DataWriter * LkaLane_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LkaLane_DataWriter> LkaLane_DataWriter_var;
            typedef DDS_DCPSInterface_out < LkaLane_DataWriter> LkaLane_DataWriter_out;


            class LkaLane_DataReader;

            typedef LkaLane_DataReader * LkaLane_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LkaLane_DataReader> LkaLane_DataReader_var;
            typedef DDS_DCPSInterface_out < LkaLane_DataReader> LkaLane_DataReader_out;


            class LkaLane_DataReaderView;

            typedef LkaLane_DataReaderView * LkaLane_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LkaLane_DataReaderView> LkaLane_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LkaLane_DataReaderView> LkaLane_DataReaderView_out;

            struct LkaLane_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LkaLane_, struct LkaLane_Seq_uniq_> LkaLane_Seq;
            typedef DDS_DCPSSequence_var < LkaLane_Seq> LkaLane_Seq_var;
            typedef DDS_DCPSSequence_out < LkaLane_Seq> LkaLane_Seq_out;

            class  LkaLane_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LkaLane_TypeSupportInterface_ptr _ptr_type;
                typedef LkaLane_TypeSupportInterface_var _var_type;

                static LkaLane_TypeSupportInterface_ptr _duplicate (LkaLane_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaLane_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LkaLane_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaLane_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaLane_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LkaLane_TypeSupportInterface () {};
                ~LkaLane_TypeSupportInterface () {};
            private:
                LkaLane_TypeSupportInterface (const LkaLane_TypeSupportInterface &);
                LkaLane_TypeSupportInterface & operator = (const LkaLane_TypeSupportInterface &);
            };

            class  LkaLane_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LkaLane_DataWriter_ptr _ptr_type;
                typedef LkaLane_DataWriter_var _var_type;

                static LkaLane_DataWriter_ptr _duplicate (LkaLane_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaLane_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LkaLane_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaLane_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaLane_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LkaLane_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LkaLane_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LkaLane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LkaLane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LkaLane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LkaLane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LkaLane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LkaLane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LkaLane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LkaLane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LkaLane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaLane_& instance_data) = 0;

            protected:
                LkaLane_DataWriter () {};
                ~LkaLane_DataWriter () {};
            private:
                LkaLane_DataWriter (const LkaLane_DataWriter &);
                LkaLane_DataWriter & operator = (const LkaLane_DataWriter &);
            };

            class  LkaLane_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LkaLane_DataReader_ptr _ptr_type;
                typedef LkaLane_DataReader_var _var_type;

                static LkaLane_DataReader_ptr _duplicate (LkaLane_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaLane_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LkaLane_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaLane_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaLane_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LkaLane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LkaLane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LkaLane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaLane_& instance) = 0;

            protected:
                LkaLane_DataReader () {};
                ~LkaLane_DataReader () {};
            private:
                LkaLane_DataReader (const LkaLane_DataReader &);
                LkaLane_DataReader & operator = (const LkaLane_DataReader &);
            };

            class  LkaLane_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LkaLane_DataReaderView_ptr _ptr_type;
                typedef LkaLane_DataReaderView_var _var_type;

                static LkaLane_DataReaderView_ptr _duplicate (LkaLane_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaLane_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LkaLane_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaLane_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaLane_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LkaLane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LkaLane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LkaLane_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LkaLane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaLane_& instance) = 0;

            protected:
                LkaLane_DataReaderView () {};
                ~LkaLane_DataReaderView () {};
            private:
                LkaLane_DataReaderView (const LkaLane_DataReaderView &);
                LkaLane_DataReaderView & operator = (const LkaLane_DataReaderView &);
            };
        }

    }

}

#endif
