#ifndef _H_880BB494445F640295072A08C63B9E6A_LkaNumOfNextLaneMarkersReported_DCPS_H_
#define _H_880BB494445F640295072A08C63B9E6A_LkaNumOfNextLaneMarkersReported_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LkaNumOfNextLaneMarkersReported_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LkaNumOfNextLaneMarkersReported_TypeSupportInterface;

            typedef LkaNumOfNextLaneMarkersReported_TypeSupportInterface * LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LkaNumOfNextLaneMarkersReported_TypeSupportInterface> LkaNumOfNextLaneMarkersReported_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LkaNumOfNextLaneMarkersReported_TypeSupportInterface> LkaNumOfNextLaneMarkersReported_TypeSupportInterface_out;


            class LkaNumOfNextLaneMarkersReported_DataWriter;

            typedef LkaNumOfNextLaneMarkersReported_DataWriter * LkaNumOfNextLaneMarkersReported_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LkaNumOfNextLaneMarkersReported_DataWriter> LkaNumOfNextLaneMarkersReported_DataWriter_var;
            typedef DDS_DCPSInterface_out < LkaNumOfNextLaneMarkersReported_DataWriter> LkaNumOfNextLaneMarkersReported_DataWriter_out;


            class LkaNumOfNextLaneMarkersReported_DataReader;

            typedef LkaNumOfNextLaneMarkersReported_DataReader * LkaNumOfNextLaneMarkersReported_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LkaNumOfNextLaneMarkersReported_DataReader> LkaNumOfNextLaneMarkersReported_DataReader_var;
            typedef DDS_DCPSInterface_out < LkaNumOfNextLaneMarkersReported_DataReader> LkaNumOfNextLaneMarkersReported_DataReader_out;


            class LkaNumOfNextLaneMarkersReported_DataReaderView;

            typedef LkaNumOfNextLaneMarkersReported_DataReaderView * LkaNumOfNextLaneMarkersReported_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LkaNumOfNextLaneMarkersReported_DataReaderView> LkaNumOfNextLaneMarkersReported_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LkaNumOfNextLaneMarkersReported_DataReaderView> LkaNumOfNextLaneMarkersReported_DataReaderView_out;

            struct LkaNumOfNextLaneMarkersReported_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LkaNumOfNextLaneMarkersReported_, struct LkaNumOfNextLaneMarkersReported_Seq_uniq_> LkaNumOfNextLaneMarkersReported_Seq;
            typedef DDS_DCPSSequence_var < LkaNumOfNextLaneMarkersReported_Seq> LkaNumOfNextLaneMarkersReported_Seq_var;
            typedef DDS_DCPSSequence_out < LkaNumOfNextLaneMarkersReported_Seq> LkaNumOfNextLaneMarkersReported_Seq_out;

            class  LkaNumOfNextLaneMarkersReported_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _ptr_type;
                typedef LkaNumOfNextLaneMarkersReported_TypeSupportInterface_var _var_type;

                static LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _duplicate (LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaNumOfNextLaneMarkersReported_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LkaNumOfNextLaneMarkersReported_TypeSupportInterface () {};
                ~LkaNumOfNextLaneMarkersReported_TypeSupportInterface () {};
            private:
                LkaNumOfNextLaneMarkersReported_TypeSupportInterface (const LkaNumOfNextLaneMarkersReported_TypeSupportInterface &);
                LkaNumOfNextLaneMarkersReported_TypeSupportInterface & operator = (const LkaNumOfNextLaneMarkersReported_TypeSupportInterface &);
            };

            class  LkaNumOfNextLaneMarkersReported_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LkaNumOfNextLaneMarkersReported_DataWriter_ptr _ptr_type;
                typedef LkaNumOfNextLaneMarkersReported_DataWriter_var _var_type;

                static LkaNumOfNextLaneMarkersReported_DataWriter_ptr _duplicate (LkaNumOfNextLaneMarkersReported_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaNumOfNextLaneMarkersReported_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaNumOfNextLaneMarkersReported_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LkaNumOfNextLaneMarkersReported_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LkaNumOfNextLaneMarkersReported_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LkaNumOfNextLaneMarkersReported_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LkaNumOfNextLaneMarkersReported_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaNumOfNextLaneMarkersReported_& instance_data) = 0;

            protected:
                LkaNumOfNextLaneMarkersReported_DataWriter () {};
                ~LkaNumOfNextLaneMarkersReported_DataWriter () {};
            private:
                LkaNumOfNextLaneMarkersReported_DataWriter (const LkaNumOfNextLaneMarkersReported_DataWriter &);
                LkaNumOfNextLaneMarkersReported_DataWriter & operator = (const LkaNumOfNextLaneMarkersReported_DataWriter &);
            };

            class  LkaNumOfNextLaneMarkersReported_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LkaNumOfNextLaneMarkersReported_DataReader_ptr _ptr_type;
                typedef LkaNumOfNextLaneMarkersReported_DataReader_var _var_type;

                static LkaNumOfNextLaneMarkersReported_DataReader_ptr _duplicate (LkaNumOfNextLaneMarkersReported_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaNumOfNextLaneMarkersReported_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaNumOfNextLaneMarkersReported_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LkaNumOfNextLaneMarkersReported_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LkaNumOfNextLaneMarkersReported_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LkaNumOfNextLaneMarkersReported_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaNumOfNextLaneMarkersReported_& instance) = 0;

            protected:
                LkaNumOfNextLaneMarkersReported_DataReader () {};
                ~LkaNumOfNextLaneMarkersReported_DataReader () {};
            private:
                LkaNumOfNextLaneMarkersReported_DataReader (const LkaNumOfNextLaneMarkersReported_DataReader &);
                LkaNumOfNextLaneMarkersReported_DataReader & operator = (const LkaNumOfNextLaneMarkersReported_DataReader &);
            };

            class  LkaNumOfNextLaneMarkersReported_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _ptr_type;
                typedef LkaNumOfNextLaneMarkersReported_DataReaderView_var _var_type;

                static LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _duplicate (LkaNumOfNextLaneMarkersReported_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LkaNumOfNextLaneMarkersReported_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LkaNumOfNextLaneMarkersReported_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LkaNumOfNextLaneMarkersReported_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LkaNumOfNextLaneMarkersReported_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LkaNumOfNextLaneMarkersReported_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LkaNumOfNextLaneMarkersReported_& instance) = 0;

            protected:
                LkaNumOfNextLaneMarkersReported_DataReaderView () {};
                ~LkaNumOfNextLaneMarkersReported_DataReaderView () {};
            private:
                LkaNumOfNextLaneMarkersReported_DataReaderView (const LkaNumOfNextLaneMarkersReported_DataReaderView &);
                LkaNumOfNextLaneMarkersReported_DataReaderView & operator = (const LkaNumOfNextLaneMarkersReported_DataReaderView &);
            };
        }

    }

}

#endif
