#ifndef _H_1D5370846768A4A6416B7468057F5B29_ObstacleStatus__H_
#define _H_1D5370846768A4A6416B7468057F5B29_ObstacleStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ObstacleStatus_Constants
            {
                const ::DDS::Octet STOP_GO_STOP_ = 0;

                const ::DDS::Octet STOP_GO_GO_ = 1;

                const ::DDS::Octet STOP_GO_UNDECIDED_ = 2;

                const ::DDS::Octet STOP_GO_DRIVER_DECISION_REQUIRED_ = 3;

                const ::DDS::Octet STOP_GO_NOT_CALCULATED_ = 15;

                const ::DDS::Octet FAILSAFE_NONE_ = 0;

                const ::DDS::Octet FAILSAFE_LOW_SUN_ = 1;

                const ::DDS::Octet FAILSAFE_BLUR_IMAGE_ = 2;

            }

            struct  ObstacleStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort num_obstacles_;
                ::DDS::UShort timestamp_;
                ::DDS::UShort application_version_;
                ::DDS::UShort active_version_number_section_;
                ::DDS::Boolean left_close_range_cut_in_;
                ::DDS::Boolean right_close_range_cut_in_;
                ::DDS::Octet stop_go_;
                ::DDS::Octet protocol_version_;
                ::DDS::Boolean close_car_;
                ::DDS::Octet failsafe_;
            };

            typedef DDS_DCPSStruct_var<ObstacleStatus_> ObstacleStatus__var;
            typedef DDS_DCPSStruct_out < ObstacleStatus_> ObstacleStatus__out;

        }

    }

}

#endif /* _H_1D5370846768A4A6416B7468057F5B29_ObstacleStatus__H_ */
