#ifndef _H_F64D731F6CA4EC7E1A5C5889096F4440_TsrVisionOnly_DCPS_H_
#define _H_F64D731F6CA4EC7E1A5C5889096F4440_TsrVisionOnly_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TsrVisionOnly_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TsrVisionOnly_TypeSupportInterface;

            typedef TsrVisionOnly_TypeSupportInterface * TsrVisionOnly_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TsrVisionOnly_TypeSupportInterface> TsrVisionOnly_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TsrVisionOnly_TypeSupportInterface> TsrVisionOnly_TypeSupportInterface_out;


            class TsrVisionOnly_DataWriter;

            typedef TsrVisionOnly_DataWriter * TsrVisionOnly_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TsrVisionOnly_DataWriter> TsrVisionOnly_DataWriter_var;
            typedef DDS_DCPSInterface_out < TsrVisionOnly_DataWriter> TsrVisionOnly_DataWriter_out;


            class TsrVisionOnly_DataReader;

            typedef TsrVisionOnly_DataReader * TsrVisionOnly_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TsrVisionOnly_DataReader> TsrVisionOnly_DataReader_var;
            typedef DDS_DCPSInterface_out < TsrVisionOnly_DataReader> TsrVisionOnly_DataReader_out;


            class TsrVisionOnly_DataReaderView;

            typedef TsrVisionOnly_DataReaderView * TsrVisionOnly_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TsrVisionOnly_DataReaderView> TsrVisionOnly_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TsrVisionOnly_DataReaderView> TsrVisionOnly_DataReaderView_out;

            struct TsrVisionOnly_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TsrVisionOnly_, struct TsrVisionOnly_Seq_uniq_> TsrVisionOnly_Seq;
            typedef DDS_DCPSSequence_var < TsrVisionOnly_Seq> TsrVisionOnly_Seq_var;
            typedef DDS_DCPSSequence_out < TsrVisionOnly_Seq> TsrVisionOnly_Seq_out;

            class  TsrVisionOnly_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TsrVisionOnly_TypeSupportInterface_ptr _ptr_type;
                typedef TsrVisionOnly_TypeSupportInterface_var _var_type;

                static TsrVisionOnly_TypeSupportInterface_ptr _duplicate (TsrVisionOnly_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TsrVisionOnly_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TsrVisionOnly_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TsrVisionOnly_TypeSupportInterface () {};
                ~TsrVisionOnly_TypeSupportInterface () {};
            private:
                TsrVisionOnly_TypeSupportInterface (const TsrVisionOnly_TypeSupportInterface &);
                TsrVisionOnly_TypeSupportInterface & operator = (const TsrVisionOnly_TypeSupportInterface &);
            };

            class  TsrVisionOnly_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TsrVisionOnly_DataWriter_ptr _ptr_type;
                typedef TsrVisionOnly_DataWriter_var _var_type;

                static TsrVisionOnly_DataWriter_ptr _duplicate (TsrVisionOnly_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TsrVisionOnly_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TsrVisionOnly_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TsrVisionOnly_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TsrVisionOnly_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TsrVisionOnly_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TsrVisionOnly_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TsrVisionOnly_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TsrVisionOnly_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TsrVisionOnly_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TsrVisionOnly_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TsrVisionOnly_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TsrVisionOnly_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TsrVisionOnly_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TsrVisionOnly_& instance_data) = 0;

            protected:
                TsrVisionOnly_DataWriter () {};
                ~TsrVisionOnly_DataWriter () {};
            private:
                TsrVisionOnly_DataWriter (const TsrVisionOnly_DataWriter &);
                TsrVisionOnly_DataWriter & operator = (const TsrVisionOnly_DataWriter &);
            };

            class  TsrVisionOnly_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TsrVisionOnly_DataReader_ptr _ptr_type;
                typedef TsrVisionOnly_DataReader_var _var_type;

                static TsrVisionOnly_DataReader_ptr _duplicate (TsrVisionOnly_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TsrVisionOnly_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TsrVisionOnly_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TsrVisionOnly_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TsrVisionOnly_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TsrVisionOnly_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TsrVisionOnly_& instance) = 0;

            protected:
                TsrVisionOnly_DataReader () {};
                ~TsrVisionOnly_DataReader () {};
            private:
                TsrVisionOnly_DataReader (const TsrVisionOnly_DataReader &);
                TsrVisionOnly_DataReader & operator = (const TsrVisionOnly_DataReader &);
            };

            class  TsrVisionOnly_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TsrVisionOnly_DataReaderView_ptr _ptr_type;
                typedef TsrVisionOnly_DataReaderView_var _var_type;

                static TsrVisionOnly_DataReaderView_ptr _duplicate (TsrVisionOnly_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TsrVisionOnly_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TsrVisionOnly_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TsrVisionOnly_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TsrVisionOnly_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TsrVisionOnly_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TsrVisionOnly_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TsrVisionOnly_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TsrVisionOnly_& instance) = 0;

            protected:
                TsrVisionOnly_DataReaderView () {};
                ~TsrVisionOnly_DataReaderView () {};
            private:
                TsrVisionOnly_DataReaderView (const TsrVisionOnly_DataReaderView &);
                TsrVisionOnly_DataReaderView & operator = (const TsrVisionOnly_DataReaderView &);
            };
        }

    }

}

#endif
